"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var BaseMessage_1 = require("./BaseMessage");
var xhr_1 = require("../utils/xhr");
var omggif_1 = require("omggif");
var ImgMessage = /** @class */ (function (_super) {
    __extends(ImgMessage, _super);
    function ImgMessage(msg) {
        var _this_1 = _super.call(this) || this;
        _this_1.ImgMessageConfig = {
            url: '',
            width: 0,
            height: 0
        };
        _this_1.numFrames = 0;
        _this_1.currentFrameIndex = 0;
        _this_1.pixels = new Uint8ClampedArray(0);
        _this_1.lastFrameDate = new Date().getTime();
        _this_1.ImgMessageConfig = Object.assign({}, _this_1.ImgMessageConfig, msg);
        return _this_1;
    }
    ImgMessage.prototype.onCreate = function (cal) {
        var _this = this;
        xhr_1.ajax({
            url: this.ImgMessageConfig.url,
            callback: function (err, res) {
                if (err) {
                    console.log(err);
                    cal(false);
                }
                else {
                    // tslint:disable-next-line: no-floating-promises
                    _this.newMethod(res);
                }
            }
        });
    };
    ImgMessage.prototype.newMethod = function (res) {
        // tslint:disable-next-line: no-floating-promises
        this.mGifReader = new omggif_1.default.GifReader(res);
        this.numFrames = this.mGifReader.numFrames();
        var frame0Info = this.mGifReader.frameInfo(0);
        var _a = [frame0Info.width, frame0Info.height], width = _a[0], height = _a[1];
        this.pixels = new Uint8ClampedArray(width * height * 4);
    };
    ImgMessage.prototype.onMeasure = function (ctx, trackInfo) {
        var reader = this.mGifReader;
        if (this.currentFrameIndex >= this.numFrames) {
            this.currentFrameIndex = 0;
        }
        var frameInfo = {
            width: this.ImgMessageConfig.width,
            height: this.ImgMessageConfig.height
        };
        if (reader) {
            frameInfo = reader.frameInfo(this.currentFrameIndex);
            // this.lastFrameDate = new Date().getTime() + frameInfo.delay
            reader.decodeAndBlitFrameRGBA(this.currentFrameIndex, this.pixels);
        }
        return {
            width: this.ImgMessageConfig.width,
            height: this.ImgMessageConfig.height
        };
    };
    ImgMessage.prototype.onLayout = function (ctx, trackInfo) {
        if (!this.isLayout) {
            this.isLayout = true;
            return {
                top: trackInfo.top,
                left: ctx.canvas.width
            };
        }
        this.position.left -= 3;
        return this.position;
    };
    ImgMessage.prototype.onDraw = function (ctx, trackInfo) {
        var imageData = new ImageData(this.pixels, this.size.width, this.size.height);
        ctx.putImageData(imageData, this.position.left, this.position.top);
    };
    ImgMessage.prototype.onDestroyed = function () {
        var result = this.position.left < -this.size.width;
        return result;
    };
    return ImgMessage;
}(BaseMessage_1.BaseMessage));
exports.default = ImgMessage;
//# sourceMappingURL=GifMessage.js.map