"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var BaseMessage_1 = require("./BaseMessage");
var TextMessage = /** @class */ (function (_super) {
    __extends(TextMessage, _super);
    function TextMessage(msg) {
        var _this = _super.call(this) || this;
        _this.textMessageConfig = {
            mMsg: '',
            color: '#FFF',
            strokeColor: '#000',
            fontSize: 30,
            fontFamily: '黑体'
        };
        _this.textMessageConfig = Object.assign({}, _this.textMessageConfig, msg);
        return _this;
    }
    TextMessage.prototype.onCreate = function (callback) {
        callback(true);
    };
    TextMessage.prototype.onMeasure = function (ctx, trackInfo) {
        ctx.textAlign = 'left';
        ctx.textBaseline = 'middle';
        ctx.font = this.textMessageConfig.fontSize + "px " + this.textMessageConfig.fontFamily;
        var res = ctx.measureText(this.textMessageConfig.mMsg);
        return {
            width: res.width,
            height: trackInfo.height
        };
    };
    TextMessage.prototype.onLayout = function (ctx, trackInfo) {
        if (!this.isLayout) {
            this.isLayout = true;
            return {
                top: trackInfo.top + trackInfo.height / 2,
                left: ctx.canvas.width
            };
        }
        this.position.left -= 3;
        return this.position;
    };
    TextMessage.prototype.onDraw = function (ctx, trackInfo) {
        ctx.fillStyle = this.textMessageConfig.strokeColor;
        ctx.strokeText(this.textMessageConfig.mMsg, this.position.left, this.position.top);
        ctx.fillStyle = this.textMessageConfig.color;
        ctx.fillText(this.textMessageConfig.mMsg, this.position.left, this.position.top);
    };
    TextMessage.prototype.onDestroyed = function () {
        return this.position.left < -this.size.width;
    };
    return TextMessage;
}(BaseMessage_1.BaseMessage));
exports.default = TextMessage;
//# sourceMappingURL=TextMessage.js.map